% function [data, xl, yl] = loadMATdata(filename)
%
% load data in matlab .mat file.
% The data in the mat file should have X and Y and one more representing the height.
% x (y) coordinate name starts with x (y) and 
% the height name can be anything so long as the name does not start with x nor y.
%
% value at (x, y) = (xl(i), yl(j)) is val(j,i)
%
% Feb 14, 2019
%   first implementation
%

function [data, xl, yl] = loadMATdata(filename)

load(filename);
clear filename
whonames = who;

indX = find( strncmpi(whonames, 'X', 1), 1 );
eval( strcat('val___ = ', whonames{indX}, ';' ) );
[ind,~] = size( val___ );
if ind == 1 || val___(2,1) == val___(1,1)
    xl = val___(1,:);
else
    xl = val___(:,1);
end

indY = find( strncmpi(whonames, 'Y', 1), 1 );
eval( strcat('val___ = ', whonames{indY}, ';' ) );
[ind,~] = size( val___ );
if ind == 1 || val___(2,1) == val___(1,1)
    yl = val___(1,:);
else
    yl = val___(:,1);
end

ind = find( 1:length(whonames) ~= indX & 1:length(whonames) ~= indY, 1 );
eval( strcat('data = ', whonames{ind}, ';') );
